# octavia.controller.worker.v1 package

## Subpackages

- octavia.controller.worker.v1.flows package
  - Submodules
  - octavia.controller.worker.v1.flows.amphora_flows module
  - octavia.controller.worker.v1.flows.health_monitor_flows module
  - octavia.controller.worker.v1.flows.l7policy_flows module
  - octavia.controller.worker.v1.flows.l7rule_flows module
  - octavia.controller.worker.v1.flows.listener_flows module
  - octavia.controller.worker.v1.flows.load_balancer_flows module
  - octavia.controller.worker.v1.flows.member_flows module
  - octavia.controller.worker.v1.flows.pool_flows module
  - Module contents
- octavia.controller.worker.v1.tasks package
  - Submodules
  - octavia.controller.worker.v1.tasks.amphora_driver_tasks module
  - octavia.controller.worker.v1.tasks.cert_task module
  - octavia.controller.worker.v1.tasks.compute_tasks module
  - octavia.controller.worker.v1.tasks.database_tasks module
  - octavia.controller.worker.v1.tasks.lifecycle_tasks module
  - octavia.controller.worker.v1.tasks.model_tasks module
  - octavia.controller.worker.v1.tasks.network_tasks module
  - octavia.controller.worker.v1.tasks.retry_tasks module
  - Module contents

## Submodules

## octavia.controller.worker.v1.controller_worker module

class ControllerWorker

  Bases: `octavia.common.base_taskflow.BaseTaskFlowEngine`

  amphora_cert_rotation(amphora_id)

    Perform cert rotation for an amphora.

    Parameters

      amphora_id – ID for amphora to rotate

    Returns

      None

    Raises

      AmphoraNotFound – The referenced amphora was not found

  batch_update_members(old_member_ids, new_member_ids, updated_members)
  create_health_monitor(health_monitor_id)

    Creates a health monitor.

    Parameters

      pool_id – ID of the pool to create a health monitor on

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  create_l7policy(l7policy_id)

    Creates an L7 Policy.

    Parameters

      l7policy_id – ID of the l7policy to create

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  create_l7rule(l7rule_id)

    Creates an L7 Rule.

    Parameters

      l7rule_id – ID of the l7rule to create

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  create_listener(listener_id)

    Creates a listener.

    Parameters

      listener_id – ID of the listener to create

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  create_load_balancer(load_balancer_id, flavor=None, availability_zone=None)

    Creates a load balancer by allocating Amphorae.

    First tries to allocate an existing Amphora in READY state. If none are available it will attempt to build one specifically for this load balancer.

    Parameters

      load_balancer_id – ID of the load balancer to create

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  create_member(member_id)

    Creates a pool member.

    Parameters

      member_id – ID of the member to create

    Returns

      None

    Raises

      NoSuitablePool – Unable to find the node pool

  create_pool(pool_id)

    Creates a node pool.

    Parameters

      pool_id – ID of the pool to create

    Returns

      None

    Raises

      NoResultFound – Unable to find the object

  delete_amphora(amphora_id)

    Deletes an existing Amphora.

    Parameters

      amphora_id – ID of the amphora to delete

    Returns

      None

    Raises

      AmphoraNotFound – The referenced Amphora was not found

  delete_health_monitor(health_monitor_id)

    Deletes a health monitor.

    Parameters

      pool_id – ID of the pool to delete its health monitor

    Returns

      None

    Raises

      HMNotFound – The referenced health monitor was not found

  delete_l7policy(l7policy_id)

    Deletes an L7 policy.

    Parameters

      l7policy_id – ID of the l7policy to delete

    Returns

      None

    Raises

      L7PolicyNotFound – The referenced l7policy was not found

  delete_l7rule(l7rule_id)

    Deletes an L7 rule.

    Parameters

      l7rule_id – ID of the l7rule to delete

    Returns

      None

    Raises

      L7RuleNotFound – The referenced l7rule was not found

  delete_listener(listener_id)

    Deletes a listener.

    Parameters

      listener_id – ID of the listener to delete

    Returns

      None

    Raises

      ListenerNotFound – The referenced listener was not found

  delete_load_balancer(load_balancer_id, cascade=False)

    Deletes a load balancer by de-allocating Amphorae.

    Parameters

      load_balancer_id – ID of the load balancer to delete

    Returns

      None

    Raises

      LBNotFound – The referenced load balancer was not found

  delete_member(member_id)

    Deletes a pool member.

    Parameters

      member_id – ID of the member to delete

    Returns

      None

    Raises

      MemberNotFound – The referenced member was not found

  delete_pool(pool_id)

    Deletes a node pool.

    Parameters

      pool_id – ID of the pool to delete

    Returns

      None

    Raises

      PoolNotFound – The referenced pool was not found

  failover_amphora(amphora_id, reraise=False)

    Perform failover operations for an amphora.

    Note: This expects the load balancer to already be in provisioning_status=PENDING_UPDATE state.

    Parameters

      - amphora_id – ID for amphora to failover

      - reraise – If enabled reraise any caught exception

    Returns

      None

    Raises

      octavia.common.exceptions.NotFound – The referenced amphora was not found

  failover_loadbalancer(load_balancer_id)

    Perform failover operations for a load balancer.

    Note: This expects the load balancer to already be in provisioning_status=PENDING_UPDATE state.

    Parameters

      load_balancer_id – ID for load balancer to failover

    Returns

      None

    Raises

      octavia.commom.exceptions.NotFound – The load balancer was not found.

  update_amphora_agent_config(amphora_id)

    Update the amphora agent configuration.

    Note: This will update the amphora agent configuration file and

      update the running configuration for mutatable configuration items.

    Parameters

      amphora_id – ID of the amphora to update.

    Returns

      None

  update_health_monitor(health_monitor_id, health_monitor_updates)

    Updates a health monitor.

    Parameters

      - pool_id – ID of the pool to have it’s health monitor updated

      - health_monitor_updates – Dict containing updated health monitor

    Returns

      None

    Raises

      HMNotFound – The referenced health monitor was not found

  update_l7policy(l7policy_id, l7policy_updates)

    Updates an L7 policy.

    Parameters

      - l7policy_id – ID of the l7policy to update

      - l7policy_updates – Dict containing updated l7policy attributes

    Returns

      None

    Raises

      L7PolicyNotFound – The referenced l7policy was not found

  update_l7rule(l7rule_id, l7rule_updates)

    Updates an L7 rule.

    Parameters

      - l7rule_id – ID of the l7rule to update

      - l7rule_updates – Dict containing updated l7rule attributes

    Returns

      None

    Raises

      L7RuleNotFound – The referenced l7rule was not found

  update_listener(listener_id, listener_updates)

    Updates a listener.

    Parameters

      - listener_id – ID of the listener to update

      - listener_updates – Dict containing updated listener attributes

    Returns

      None

    Raises

      ListenerNotFound – The referenced listener was not found

  update_load_balancer(load_balancer_id, load_balancer_updates)

    Updates a load balancer.

    Parameters

      - load_balancer_id – ID of the load balancer to update

      - load_balancer_updates – Dict containing updated load balancer

    Returns

      None

    Raises

      LBNotFound – The referenced load balancer was not found

  update_member(member_id, member_updates)

    Updates a pool member.

    Parameters

      - member_id – ID of the member to update

      - member_updates – Dict containing updated member attributes

    Returns

      None

    Raises

      MemberNotFound – The referenced member was not found

  update_pool(pool_id, pool_updates)

    Updates a node pool.

    Parameters

      - pool_id – ID of the pool to update

      - pool_updates – Dict containing updated pool attributes

    Returns

      None

    Raises

      PoolNotFound – The referenced pool was not found

## Module contents

this page last updated: 2026-03-10 21:33:29

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug